Codeforcess 535C Tavas and Karafs【二分+思维】

来源:互联网 发布:淘宝会员名大全女生 编辑:程序博客网 时间:2024/05/23 23:30

C. Tavas and Karafs
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Karafs is some kind of vegetable in shape of an1 × h rectangle. Tavaspolis people love Karafs and they use Karafs in almost any kind of food. Tavas, himself, is crazy about Karafs.

Each Karafs has a positive integer height. Tavas has an infinite 1-based sequence of Karafses. The height of the i-th Karafs issi = A + (i - 1) × B.

For a given m, let's define an m-bite operation as decreasing the height of at most m distinct not eaten Karafses by 1. Karafs is considered as eaten when its height becomes zero.

Now SaDDas asks you n queries. In each query he gives you numbersl, t andm and you should find the largest number r such that l ≤ r and sequencesl, sl + 1, ..., sr can be eatenby performing m-bite no more thant times or print -1 if there is no such numberr.

Input

The first line of input contains three integers A,B and n (1 ≤ A, B ≤ 106,1 ≤ n ≤ 105).

Next n lines contain information about queries.i-th line contains integers l, t, m (1 ≤ l, t, m ≤ 106) fori-th query.

Output

For each query, print its answer in a single line.

Examples
Input
2 1 41 5 33 3 107 10 26 4 8
Output
4-18-1
Input
1 5 21 5 102 7 4
Output
12

题目大意:

现在给你一个以A为基,B为公差的等差数列(无现长),其中有N个询问。

对于N个询问,每个询问有三个元素,l,t,m;

表示我们现在有t次操作,每次可以选择m个数将其都-1.

现在问你能够使得以l为起点,r为终点最远的r,区间【l,r】所有数都减少为0.


思路:


1、显然这个终点r越远,需要的操作就越多,其具有单调性,那么我们二分终点。进行判断。

如果当前终点可行,那么让这个终点更远一些,否则就更近一些。


2、对于判定:

显然我们要满足两个条件才能叫可行:
①从起点到当前终点mid所有的数都小于等于t.其实就是判断a【mid】是否小于等于t.

②从起点到当前终点mid所有的数的和小于t*m.表示我们需要在t次内将所有数都减少为0.


3、题目并不难,读懂题最重要。


Ac代码:

#include<stdio.h>#include<string.h>using namespace std;#define ll __int64ll A,B,n;ll get(ll mid){    return A+(mid-1)*B;}ll getsum(ll l,ll r){    ll rr=(A+A+(r-1)*B)*r/2;    ll lll=(A+A+(l-2)*B)*(l-1)/2;    return rr-lll;}int main(){    while(~scanf("%I64d%I64d%I64d",&A,&B,&n))    {        for(ll i=0;i<n;i++)        {            ll s,t,m;            scanf("%I64d%I64d%I64d",&s,&t,&m);            ll left=s;            ll right=1000000000;            ll ans=-1;            while(right-left>=0)            {                ll mid=(right+left)/2;                if(get(mid)>t)right=mid-1;                else                {                    if(getsum(s,mid)>m*t)                    {                        right=mid-1;                    }                    else                    {                        ans=mid;                        left=mid+1;                    }                }            }            printf("%d\n",ans);        }    }}







0 0
原创粉丝点击